from cProfile import label
from operator import mod
from select import select
from statistics import mode

from this import d
import time
from scipy import rand
import torch
import scipy.io
import matplotlib.pyplot as plt
import matplotlib as mpl
import numpy as np
from torch import batch_norm, double, nn
from torch.utils.data import TensorDataset
from torch_geometric.data import Data
from torch.nn import BatchNorm1d
import torch.nn.functional as F
from torch_geometric.loader import DataLoader, DenseDataLoader
from torch_geometric.nn import GCNConv, ChebConv, GraphNorm, MessageNorm, TAGConv, GINConv ,GINEConv, ARMAConv, SGConv, APPNP, EdgePooling
from torch_geometric.data import InMemoryDataset, download_url
from tqdm import tqdm
import random
from sklearn.decomposition import FactorAnalysis
from sklearn.decomposition import PCA
from tqdm import tqdm
from models import DGC, GCN

import torchvision
from confusion import *
from train import *

class AddGaussianNoise(object):
    def __init__(self, mean=0., std=1.):
        self.std = std
        self.mean = mean
        
    def __call__(self, tensor):
        return tensor + torch.randn(tensor.size()) * self.std + self.mean
    
    def __repr__(self):
        return self.__class__.__name__ + '(mean={0}, std={1})'.format(self.mean, self.std)
        

def applyPCA(X, numComponents=100):
     newX = np.reshape(X, (-1, X.shape[2]))
     pca = PCA(n_components=numComponents, whiten=True)
     newX = pca.fit_transform(newX)
     newX = np.reshape(newX, (X.shape[0],X.shape[1], numComponents))
     return newX, pca


dataset_list = [ "H2011216003423_3"]

loss_list_salinas = []
accuracy_list_salinas = []
val_loss_list_salinas = []
val_acc_list_salinas = []
final_salinas_accuracy = 0

loss_list_indian = []
accuracy_list_indian = []
val_loss_list_indian = []
val_acc_list_indian = []
final_indian_accuracy = 0

for dataset in dataset_list:
    std_list = []
    print("Making dataset")

    data, targets = load_dataset(dataset)



    class AddGaussianNoise(object):
        def __init__(self, mean=0, std=1.):
            self.std = std
            self.mean = mean
            
        def __call__(self, tensor):
            return tensor + torch.randn(tensor.size()) * self.std + self.mean
        
        def __repr__(self):
            return self.__class__.__name__ + '(mean={12.69}, std={1})'.format(self.mean, self.std)




    #data, pca = applyPCA(data)

    print(np.amax(data))
    print(np.amin(data))

    print(data.shape)



    transform = torchvision.transforms.Compose([AddGaussianNoise()])

    augment = False

    train_data, train_targets, val_data, val_targets = split_training_data(data, targets, 0.3)

    train_data_fliped = np.flip(train_data, 1)
    train_targets_fliped = np.flip(train_targets, 1)

    if augment:
        train_data = torch.FloatTensor(train_data)

        train_data_augmented = transform(train_data)

        train_data = torch.cat((train_data, train_data_augmented))
        train_data = train_data.numpy()

        train_targets = np.concatenate((train_targets, train_targets))




    """train_data_avg = avrage_pixels(train_data, train_targets)
    train_data = np.concatenate((train_data, train_data_avg))
    train_targets = np.concatenate((train_targets, train_targets))"""



    train_data = np.concatenate((train_data, train_data_fliped))
    train_targets = np.concatenate((train_targets, train_targets_fliped))

    train_data = make_training_data(train_data, train_targets, 30, 2)





    val_data = make_test_data(val_data, val_targets)

    train_dataloader = DataLoader(train_data, batch_size=15, shuffle=True)

    """train_dataloader.transform = torchvision.transforms.Compose([
        AddGaussianNoise(0., 1.)])"""

    val_dataloader = DataLoader(val_data)
    #plt.imshow(targets)
    #plt.show()

    print("Initiating training")
    #dataloader_iterator = iter(train_dataloader)

    #data, target = next(dataloader_iterator)

    #convert to graph
    #loader = DataLoader(datalist, shuffle=False)


    m = 0.8

        


    number_of_loops = 10
    temp = 0

    loss_list = []

    for loop in range(number_of_loops):
        ################################
        #Training section
        model_name = "dc"

        device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')

        if model_name == "dgc":
            model = DGC().to(device)
        else:
            model = GCN().to(device)
            #lr = 0.0005
        optimizer = torch.optim.Adam(model.parameters(), lr=0.01, weight_decay=5e-4)
        loss = 100
        best_loss = 100
        times_no_new_best_loss = 0
        

        number_of_epochs = 25
        for i in tqdm(range(number_of_epochs)):
            avg_train_loss, avg_train_accuracy = train_loop(train_dataloader, model, optimizer, device)
            #val_loss, val_accuracy = val_loop(val_dataloader, model, device)

            avg_train_loss = avg_train_loss.data.cpu().numpy()
            if dataset == "Indian_pines_corrected":
                loss_list_indian.append(avg_train_loss)
                accuracy_list_indian.append(avg_train_accuracy)
                #val_loss_list_indian.append(val_loss)
                #val_acc_list_indian.append(val_accuracy)
            elif dataset == "SalinasA":
                loss_list_salinas.append(avg_train_loss)
                accuracy_list_salinas.append(avg_train_accuracy)
                #val_loss_list_salinas.append(val_loss)
                #val_acc_list_salinas.append(val_accuracy)
            #print(avg_loss)
            
            if avg_train_loss < best_loss:
                times_no_new_best_loss = 0
                best_loss = avg_train_loss
                #print("Saving model")
                torch.save(model.state_dict(), "best_model")
            else:
                times_no_new_best_loss += 1
            #if times_no_new_best_loss == 60:
            #   break
        ################################
        print(best_loss)
        """plt.plot(loss_list)
        plt.show()
        loss_list = []"""
        if model_name == "dgc":
            model = DGC().to(device)
        else:
            model = GCN().to(device)
        
        
        accuracy, predicted_image = test_loop(val_dataloader, model, device)
        class_numbers = ['1' ,'2', '3']
        confusion_matrix = get_confusion_matrix(predicted_image, val_targets, class_numbers)
        plot_confusion_matrix(confusion_matrix, dataset)
        std_list.append(accuracy)
        temp += accuracy

    avg_accuracy = temp/number_of_loops

    print("Avg test accuracy: ", avg_accuracy)
    print("Standard deviation: ", np.std(std_list))
    #predicted_image = predicted_image.cpu()
    
    if dataset == "Indian_pines_corrected":
        final_indian_accuracy = accuracy
    elif dataset == "SalinasA":
        final_salinas_accuracy = accuracy



    test_data = make_test_data(data, targets)

        

    test_dataloader = DataLoader(test_data)
    
    accuracy, predicted_image = test_loop(test_dataloader, model, device)

  
    #f, axarr = plt.subplots(1,2)
    colors = ['green', 'blue']


    cmap = mpl.colors.ListedColormap(colors)
    #plt.imshow(predicted_image, interpolation='none', cmap=cmap)
    plt.imsave(dataset + '_prediction.png', predicted_image)

    plt.imsave(dataset + '_ground_truth.png', targets)
    """axarr[0].imshow(predicted_image)
    axarr[1].imshow(targets)"""

    #plt.show()


f, axarr = plt.subplots(1,2)
axarr[0].plot(loss_list_indian, label='Indian pines')
axarr[0].plot(loss_list_salinas, label='SalinasA')
axarr[0].legend(loc='upper right')
axarr[0].title.set_text('Training loss')
axarr[1].plot(accuracy_list_indian, label='Indian pines')
axarr[1].plot(accuracy_list_salinas, label='SalinasA')

axarr[1].legend(loc='lower right')
axarr[1].title.set_text('Training accuracy')

plt.show()


    #plt.imshow(np.expand_dims(data.y, axis=1))

    #plt.show()

